{"openapi":"3.1.0","info":{"title":"BankSync API","version":"1.0.0","description":"Connect bank accounts and sync financial data to Notion, Google Sheets, and Airtable. Authenticate with an API key (X-API-Key header) or a Firebase ID token (Bearer). Every /v1 request counts toward a per-workspace, per-minute rate limit set by the plan; on Free and Starter only GET /v1/whoami answers (metered at the Standard rate) and every other /v1 operation returns 403 (Standard 10, Professional 20, Business 30). Over the limit, any operation returns 429 with Retry-After, X-RateLimit-Limit and X-RateLimit-Policy headers; wait Retry-After seconds before retrying. See https://banksync.io/docs/api/rest-api#rate-limits.","contact":{"name":"BankSync Support","url":"https://banksync.io"}},"servers":[{"url":"https://api.banksync.io","description":"Production"}],"components":{"securitySchemes":{"apiKey":{"type":"apiKey","in":"header","name":"X-API-Key","description":"API key — pass in the X-API-Key header. Obtain from Developer Settings in the BankSync app."},"bearerAuth":{"type":"http","scheme":"bearer","description":"Firebase ID token — pass as a Bearer token in the Authorization header."}},"schemas":{"TriggerSyncBody":{"type":"object","properties":{"startDate":{"type":"string","description":"Start date (YYYY-MM-DD) for date-range syncs (transactions, trades)."},"endDate":{"type":"string","description":"End date (YYYY-MM-DD) for date-range syncs (transactions, trades)."},"forceCancelActive":{"type":"boolean","description":"When true, cancel any currently-running sync on this feed before starting the new one. Use this for user-initiated retries when the previous sync is stuck. Defaults to false."},"resetCursors":{"type":"boolean","description":"When true, clear all per-bank cursors, tier-1/tier-2 dedup state, and the date-based watermark before fetching. Use for backfills or recovery when the incremental cursor has gone stale. Defaults to false (normal incremental sync)."},"skipDedup":{"type":"boolean","description":"When true, bypass the per-record dedup guard for this run. Use for backfills where upstream IDs are known-stable but downstream dedup has drifted. Defaults to false."}}},"ConditionGroup":{"type":"object","properties":{"logic":{"type":"string","enum":["and","or"]},"conditions":{"type":"array","minItems":1,"items":{"oneOf":[{"type":"object","properties":{"field":{"type":"string"},"operator":{"type":"string"},"value":{"oneOf":[{"type":"string"},{"type":"number"}]}},"required":["field","operator"]},{"$ref":"#/components/schemas/ConditionGroup"}]}}},"required":["logic","conditions"]},"RuleAction":{"oneOf":[{"type":"object","properties":{"kind":{"type":"string","enum":["set"],"description":"Static value write (default when `kind` is absent)"},"field":{"type":"string","description":"Target field to write"},"value":{"anyOf":[{"type":"string"},{"type":"number"}],"description":"Static value to set"}},"required":["field","value"]},{"type":"object","properties":{"kind":{"type":"string","enum":["template"]},"field":{"type":"string","description":"Target field to write"},"template":{"type":"string","minLength":1,"description":"Template with {{fieldName}} placeholders; missing fields render as ''"}},"required":["kind","field","template"]},{"type":"object","properties":{"kind":{"type":"string","enum":["regexExtract"]},"field":{"type":"string","description":"Target field to write"},"source":{"type":"string","minLength":1,"description":"Source field to extract from"},"pattern":{"type":"string","minLength":1,"description":"Safe-regex-guarded pattern; the captured group is written"},"group":{"type":"integer","minimum":0,"maximum":9,"description":"Capture group to write (default 1)"}},"required":["kind","field","source","pattern"]},{"type":"object","properties":{"kind":{"type":"string","enum":["case"]},"field":{"type":"string","description":"Target field to write"},"source":{"type":"string","minLength":1,"description":"Source field (defaults to `field` — in-place recase)"},"mode":{"type":"string","enum":["upper","lower","title"]}},"required":["kind","field","mode"]},{"type":"object","properties":{"kind":{"type":"string","enum":["math"]},"field":{"type":"string","description":"Target field to write"},"source":{"type":"string","minLength":1,"description":"Source field (defaults to `field`)"},"op":{"type":"string","enum":["abs","negate","round2"]}},"required":["kind","field","op"]}]},"ActorRef":{"oneOf":[{"type":"object","properties":{"kind":{"type":"string","enum":["user"]},"userId":{"type":"string","minLength":1}},"required":["kind","userId"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["sync"]},"feedId":{"type":"string","minLength":1},"jobId":{"type":"string","minLength":1},"cause":{"type":"object","properties":{"automationId":{"type":"string","minLength":1},"runId":{"type":"string","minLength":1},"depth":{"type":"integer","minimum":1},"untrustedSender":{"type":"boolean","enum":[true]}},"required":["automationId","runId","depth"],"additionalProperties":false}},"required":["kind","feedId"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["extractor"]},"feedId":{"type":"string","minLength":1},"jobId":{"type":"string","minLength":1},"untrustedSender":{"type":"boolean","enum":[true]}},"required":["kind","feedId"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["import"]},"importId":{"type":"string","minLength":1},"userId":{"type":"string","minLength":1}},"required":["kind","importId","userId"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["api"]},"clientId":{"type":"string","minLength":1}},"required":["kind","clientId"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["system"]},"reason":{"type":"string","minLength":1}},"required":["kind","reason"],"additionalProperties":false},{"type":"object","properties":{"kind":{"type":"string","enum":["automation"]},"automationId":{"type":"string","minLength":1},"revision":{"type":"string","minLength":1},"grantId":{"type":"string","minLength":1},"runId":{"type":"string","minLength":1},"node":{"type":"string","minLength":1},"startedBy":{"$ref":"#/components/schemas/ActorRef"},"depth":{"type":"integer","minimum":1},"untrustedSender":{"type":"boolean","enum":[true]}},"required":["kind","automationId","revision","grantId","runId","node","startedBy","depth"],"additionalProperties":false}]},"FilterNode":{"anyOf":[{"type":"object","properties":{"field":{"type":"string"},"op":{"type":"string","enum":["eq","neq","gt","gte","lt","lte","in","nin","contains","starts-with","ends-with","between","is-null","is-not-null","matches","has-passed","not-passed"]},"value":{"anyOf":[{"type":"string"},{"type":"number"},{"type":"boolean"},{"nullable":true},{"type":"array","items":{"anyOf":[{"type":"string"},{"type":"number"}]}},{"type":"object","properties":{"start":{"type":"string"},"end":{"type":"string"}},"required":["start","end"],"additionalProperties":false},{"type":"object","properties":{"min":{"type":"number"},"max":{"type":"number"}},"required":["min","max"],"additionalProperties":false},{"type":"object","properties":{"rel":{"type":"string","enum":["today","yesterday","7d","30d","90d","12m","mtd","qtd","ytd"]}},"required":["rel"],"additionalProperties":false},{"type":"object","properties":{"$filter":{"type":"string"}},"required":["$filter"],"additionalProperties":false},{"type":"object","properties":{"$param":{"type":"string"}},"required":["$param"],"additionalProperties":false},{"type":"object","properties":{"$field":{"type":"string"}},"required":["$field"],"additionalProperties":false}]},"security":{"type":"boolean"},"optional":{"type":"boolean"}},"required":["field","op"],"additionalProperties":false},{"type":"object","properties":{"logic":{"type":"string","enum":["and"]},"conditions":{"type":"array","items":{"$ref":"#/components/schemas/FilterNode"}}},"required":["logic","conditions"],"additionalProperties":false},{"type":"object","properties":{"logic":{"type":"string","enum":["or"]},"conditions":{"type":"array","items":{"$ref":"#/components/schemas/FilterNode"}}},"required":["logic","conditions"],"additionalProperties":false},{"type":"object","properties":{"logic":{"type":"string","enum":["not"]},"condition":{"$ref":"#/components/schemas/FilterNode"}},"required":["logic","condition"],"additionalProperties":false}],"description":"A filter tree shared by tables, dashboards and widgets. A clause names a field by key (or one hop through a relation as `relation.field`), an operator, and a value; groups combine clauses with and / or / not.","oneOf":[{"type":"object","title":"Clause","properties":{"field":{"type":"string","description":"Field key, or `relation.field` for one hop."},"op":{"type":"string","enum":["eq","neq","gt","gte","lt","lte","in","nin","contains","starts-with","ends-with","between","is-null","is-not-null","matches","has-passed","not-passed"]},"value":{"oneOf":[{"type":"string"},{"type":"number"},{"type":"boolean"},{"type":"null"},{"type":"array","items":{"oneOf":[{"type":"string"},{"type":"number"}]}},{"type":"object","properties":{"start":{"type":"string"},"end":{"type":"string"}},"required":["start","end"],"description":"An inclusive date range."},{"type":"object","properties":{"min":{"type":"number"},"max":{"type":"number"}},"required":["min","max"],"description":"An inclusive numeric range."},{"type":"object","properties":{"rel":{"type":"string","enum":["today","yesterday","7d","30d","90d","12m","mtd","qtd","ytd"]}},"required":["rel"],"description":"A relative date range, resolved when the query runs."},{"type":"object","properties":{"$field":{"type":"string"}},"required":["$field"],"additionalProperties":false,"description":"Compare against another field of the same row, by key."},{"type":"object","properties":{"$filter":{"type":"string"}},"required":["$filter"],"additionalProperties":false,"description":"Bind to a dashboard filter by id; resolved when the dashboard renders."},{"type":"object","properties":{"$param":{"type":"string"}},"required":["$param"],"additionalProperties":false,"description":"Bind to a query parameter by name; resolved against the widget bindings."}]},"security":{"type":"boolean","description":"Server-bound clause: cannot be dropped by a viewer and is enforced at the data plane."},"optional":{"type":"boolean","description":"Skip the clause (treat as passing) for rows where `field` is absent, as opposed to present-but-null. Default false."}},"required":["field","op"],"additionalProperties":false},{"type":"object","title":"And / Or","properties":{"logic":{"type":"string","enum":["and","or"]},"conditions":{"type":"array","items":{"$ref":"#/components/schemas/FilterNode"}}},"required":["logic","conditions"],"additionalProperties":false},{"type":"object","title":"Not","properties":{"logic":{"type":"string","enum":["not"]},"condition":{"$ref":"#/components/schemas/FilterNode"}},"required":["logic","condition"],"additionalProperties":false}]},"MovedDashboard":{"type":"object","properties":{"ok":{"type":"boolean","enum":[true]},"dashboardId":{"type":"string"},"folderId":{"type":"string","nullable":true},"anchor":{"type":"string","nullable":true,"description":"The dashboard this one now sits before, or `null` when it is last"}},"required":["ok","dashboardId","folderId","anchor"]},"MoveDashboardBody":{"type":"object","properties":{"folderId":{"type":"string","nullable":true,"minLength":1,"maxLength":128,"description":"The folder to move the dashboard into; `null` for the top level"},"before":{"type":"string","nullable":true,"minLength":1,"maxLength":128,"description":"A dashboard in that folder to place this one before; `null` places it last. Omit it to keep the place, or to go last when the folder changes."}},"required":["folderId"]},"ReorderedDashboards":{"type":"object","properties":{"ok":{"type":"boolean","enum":[true]},"count":{"type":"integer","description":"Dashboards ranked"}},"required":["ok","count"]},"ReorderDashboardsBody":{"type":"object","properties":{"orderedIds":{"type":"array","items":{"type":"string","minLength":1,"maxLength":128},"minItems":1,"maxItems":500,"description":"Dashboard IDs in their new order. Dashboards not listed keep their places relative to each other."}},"required":["orderedIds"]},"Json":{"anyOf":[{"nullable":true},{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"array","items":{"allOf":[{"$ref":"#/components/schemas/Json"},{"nullable":true}]}},{"type":"object","additionalProperties":{"allOf":[{"$ref":"#/components/schemas/Json"},{"nullable":true}]}}]}},"parameters":{}},"paths":{"/v1/banks":{"get":{"operationId":"listBanks","summary":"List bank connections","description":"List banks owned by the current workspace. Pass `?scope=family` to include banks from every portal under this workspace — useful for accountants who want a single view across all client portals. Family scope requires admin+ role and is only valid on a top-level workspace.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"banks","x-flagbase-operation":"banks.list","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.banks.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["banks:read"],"x-flagbase-service-level":"first-class","parameters":[{"schema":{"type":"string","enum":["self","family"],"description":"Resource scope. `self` (default) returns this workspace only. `family` returns this workspace plus every live portal under it; each row gains a `portal: { id, name, icon } | null` badge and a `workspaceId` field. Admin+ only; top-level workspaces only."},"required":false,"description":"Resource scope. `self` (default) returns this workspace only. `family` returns this workspace plus every live portal under it; each row gains a `portal: { id, name, icon } | null` badge and a `workspaceId` field. Admin+ only; top-level workspaces only.","name":"scope","in":"query"}],"responses":{"200":{"description":"List of banks. When `scope=family`, each row additionally carries `workspaceId` and `portal`.","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"source":{"type":"string","enum":["plaid","snaptrade","saltedge","fiskil","quiltt"]},"type":{"type":"string"},"order":{"type":"number"},"icon":{"type":"string"},"connectionStatus":{"type":"object","properties":{"connected":{"type":"boolean"},"status":{"type":"string"},"errorCode":{"type":"string"},"errorMessage":{"type":"string"},"lastCheckedAt":{"type":"string"},"source":{"type":"string","enum":["provider_call","webhook","reconciler","user"]}},"additionalProperties":{"nullable":true}},"institutionId":{"type":"string"},"createdAt":{"type":"string"},"updatedAt":{"type":"string"},"links":{"type":"object","additionalProperties":{"type":"string"}}},"required":["id","name","source","type","order","createdAt","updatedAt","links"],"additionalProperties":{"nullable":true}}}},"required":["success","data"]}}}},"400":{"description":"Invalid `scope` value, or `scope=family` was requested against a portal workspace","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden — `scope=family` requires admin+ role","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/{bid}":{"get":{"operationId":"getBank","summary":"Get a bank connection","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"banks","x-flagbase-operation":"banks.get","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.banks.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["banks:read"],"x-flagbase-service-level":"first-class","parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"}],"responses":{"200":{"description":"Bank detail. A bank undergoing permanent removal, or one whose removal failed, is returned with `removalStatus` rather than 404 — otherwise a caller polling after a removal request could not tell \"gone\" from \"stuck\".","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"source":{"type":"string","enum":["plaid","snaptrade","saltedge","fiskil","quiltt"]},"type":{"type":"string"},"order":{"type":"number"},"icon":{"type":"string"},"connectionStatus":{"type":"object","properties":{"connected":{"type":"boolean"},"status":{"type":"string"},"errorCode":{"type":"string"},"errorMessage":{"type":"string"},"lastCheckedAt":{"type":"string"},"source":{"type":"string","enum":["provider_call","webhook","reconciler","user"]}},"additionalProperties":{"nullable":true}},"institutionId":{"type":"string"},"createdAt":{"type":"string"},"updatedAt":{"type":"string"},"links":{"type":"object","additionalProperties":{"type":"string"}},"removalStatus":{"type":"object","properties":{"state":{"type":"string","enum":["removing","failed"]},"reason":{"type":"string"},"stage":{"type":"string","enum":["provider","local"]}},"required":["state"],"description":"Progress of a permanent removal. `removing` = the teardown is queued or running. `failed` = it stopped and the bank was kept. A `provider` failure can be reactivated or retried; a `local` failure happened after disconnection and can only be retried."}},"required":["id","name","source","type","order","createdAt","updatedAt","links"],"additionalProperties":{"nullable":true}}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}},"delete":{"operationId":"deleteBank","summary":"Remove a bank connection","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"},{"schema":{"type":"string","enum":["true","false"],"description":"When \"true\", removes the bank permanently: the connection is revoked at the provider, everything derived from it is destroyed, and the bank is deleted immediately rather than at the next monthly cleanup. Irreversible, and requires the admin or owner role in a signed-in session: an API key or an OAuth token is refused with 403 SIGNED_IN_SESSION_REQUIRED. Defaults to a reversible soft delete."},"required":false,"description":"When \"true\", removes the bank permanently: the connection is revoked at the provider, everything derived from it is destroyed, and the bank is deleted immediately rather than at the next monthly cleanup. Irreversible, and requires the admin or owner role in a signed-in session: an API key or an OAuth token is refused with 403 SIGNED_IN_SESSION_REQUIRED. Defaults to a reversible soft delete.","name":"permanent","in":"query"}],"responses":{"200":{"description":"Bank removed","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"deleted":{"type":"boolean","enum":[true]}},"required":["deleted"]}},"required":["success","data"]}}}},"202":{"description":"Permanent removal accepted. Provider revocation and destruction run asynchronously.","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"status":{"type":"string","enum":["removing"]}},"required":["status"]}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"409":{"description":"Bank is still referenced by one or more sync feeds","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/connections/start":{"post":{"operationId":"startConnection","summary":"Start a new bank connection","description":"Initiates a provider-specific connection flow. Returns a `ConnectionStart` payload the client renders — a Plaid Link token, a portal popup URL, or an OAuth redirect URL depending on the provider.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"providerInstanceId":{"type":"string","minLength":3,"pattern":"^[a-z]+:[a-z0-9_-]+$"},"email":{"type":"string","format":"email"},"mobile":{"type":"string"},"institutionId":{"type":"string","maxLength":128},"brandId":{"type":"string","minLength":1,"maxLength":64},"countryCodes":{"type":"array","items":{"type":"string"}},"redirectUri":{"type":"string"},"brokerageSlug":{"type":"string"},"saltedgeConsentScopes":{"type":"array","items":{"type":"string","enum":["holder_info","accounts","transactions"]}},"connectionType":{"type":"string","enum":["read","trade"]},"forceNewConnection":{"type":"boolean"}},"required":["providerInstanceId","email"]}}}},"responses":{"200":{"description":"Connection flow initiated","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"oneOf":[{"type":"object","properties":{"flow":{"type":"string","enum":["plaid_link"]},"linkToken":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["plaid_public_token"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","linkToken","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["fiskil_link"]},"authSessionId":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","authSessionId","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["quiltt_connector"]},"sessionToken":{"type":"string"},"connectorId":{"type":"string"},"institutionId":{"type":"string"},"institutionTargeting":{"type":"string","enum":["id","name"]},"connectionId":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","sessionToken","connectorId","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["portal_popup"]},"url":{"type":"string"},"expiresAt":{"type":"string","format":"date-time"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","url","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["oauth_redirect"]},"url":{"type":"string"},"expiresAt":{"type":"string","format":"date-time"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","url","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["existing_connection"]},"existingBanks":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"requiresReauth":{"type":"boolean"}},"required":["id","name","requiresReauth"]}},"canCreateAdditional":{"type":"boolean"}},"required":["flow","existingBanks","canCreateAdditional"]}]}},"required":["success","data"]}}}},"400":{"description":"Invalid request","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden or plan limit reached","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"501":{"description":"Provider not available in this environment","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/connections/complete":{"post":{"operationId":"completeConnection","summary":"Complete an in-flight bank connection","description":"Exchanges the provider callback payload (public_token or connection_id) for a persisted bank connection. Returns the bank ID, whether it was newly created, and live account data.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"providerInstanceId":{"type":"string","minLength":3,"pattern":"^[a-z]+:[a-z0-9_-]+$"},"attemptId":{"type":"string","minLength":1,"maxLength":1024},"payload":{"oneOf":[{"type":"object","properties":{"kind":{"type":"string","enum":["plaid_public_token"]},"publicToken":{"type":"string"},"institutionId":{"type":"string"}},"required":["kind","publicToken"]},{"type":"object","properties":{"kind":{"type":"string","enum":["provider_connection_id"]},"connectionId":{"type":"string","minLength":1},"institutionId":{"type":"string"}},"required":["kind","connectionId"]}]}},"required":["providerInstanceId","payload"]}}}},"responses":{"200":{"description":"Connection established","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"bankId":{"type":"string"},"created":{"type":"boolean"},"accounts":{"type":"array","items":{"type":"object","additionalProperties":{"nullable":true}}}},"required":["success","bankId","created","accounts"]}}}},"400":{"description":"Invalid payload","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden or plan limit reached","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"501":{"description":"Provider not available in this environment","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/connections/{bid}/reauth":{"post":{"operationId":"reauthConnection","summary":"Reauthorise an existing bank connection","description":"Produces a new connection start payload for an existing bank. Use when the connection has expired or been revoked.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"redirectUri":{"type":"string"}}}}}},"responses":{"200":{"description":"Reauth flow initiated","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"oneOf":[{"type":"object","properties":{"flow":{"type":"string","enum":["plaid_link"]},"linkToken":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["plaid_public_token"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","linkToken","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["fiskil_link"]},"authSessionId":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","authSessionId","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["quiltt_connector"]},"sessionToken":{"type":"string"},"connectorId":{"type":"string"},"institutionId":{"type":"string"},"institutionTargeting":{"type":"string","enum":["id","name"]},"connectionId":{"type":"string"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","sessionToken","connectorId","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["portal_popup"]},"url":{"type":"string"},"expiresAt":{"type":"string","format":"date-time"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","url","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["oauth_redirect"]},"url":{"type":"string"},"expiresAt":{"type":"string","format":"date-time"},"expectedPayloadKind":{"type":"string","enum":["provider_connection_id"]},"attemptId":{"type":"string","minLength":1,"maxLength":1024}},"required":["flow","url","expectedPayloadKind"]},{"type":"object","properties":{"flow":{"type":"string","enum":["existing_connection"]},"existingBanks":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"requiresReauth":{"type":"boolean"}},"required":["id","name","requiresReauth"]}},"canCreateAdditional":{"type":"boolean"}},"required":["flow","existingBanks","canCreateAdditional"]}]}},"required":["success","data"]}}}},"400":{"description":"Invalid request","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Bank not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/search":{"post":{"operationId":"searchInstitutions","summary":"Search for financial institutions","description":"Deprecated: use POST /v1/banks/brands/search (one row per bank, every way in). Search the institution catalog for providers currently connectable in this workspace and environment. Results exclude providers whose feature gate is disabled as well as catalog-only seed data that cannot be connected in-app.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"query":{"type":"string","minLength":1,"maxLength":100},"countryCodes":{"type":"array","items":{"type":"string","minLength":2,"maxLength":2},"maxItems":20},"providerInstanceId":{"type":"string","maxLength":64}},"required":["query"]}}}},"responses":{"200":{"description":"Search results","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"institutions":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"logo":{"type":"string"},"countryCodes":{"type":"array","items":{"type":"string"}},"provider":{"type":"string"},"providerInstanceId":{"type":"string"},"region":{"type":"string"},"products":{"type":"array","items":{"type":"string"}},"url":{"type":"string"},"primaryColor":{"type":"string"},"brandKey":{"type":"string"},"routingNumbers":{"type":"array","items":{"type":"string"}},"tags":{"type":"array","items":{"type":"string"}}},"required":["id","name","countryCodes","provider"]}},"providers":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"status":{"type":"string","enum":["ok","rate_limited","failed","skipped_unsupported_country","skipped_unsupported_capability","skipped_excluded"]},"contributed":{"type":"integer","minimum":0},"error":{"type":"string"},"providerErrorCode":{"type":"string"},"retryAfter":{"type":"string","format":"date-time"}},"required":["id","status","contributed"]}}},"required":["institutions","providers"]}},"required":["success","data"]}}}},"400":{"description":"Invalid request","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/brands/search":{"post":{"operationId":"searchBrands","summary":"Search banks","description":"Search the bank catalog. One result per bank, with every way to connect it and which one we recommend, replacing the one-result-per-provider shape of /banks/search. Reads the nightly catalog only: a bank a provider listed since last night appears here after the next harvest.","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"institutions","x-flagbase-operation":"institutions.search","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.institutions.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["institutions:read"],"x-flagbase-service-level":"first-class","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"query":{"type":"string","minLength":1,"maxLength":100},"market":{"type":"string","pattern":"^[A-Za-z]{2}$"},"limit":{"type":"integer","minimum":1,"maximum":50}},"required":["query"]}}}},"responses":{"200":{"description":"Matching banks","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"brands":{"type":"array","items":{"type":"object","properties":{"key":{"type":"string"},"name":{"type":"string"},"slug":{"type":"string","nullable":true},"market":{"type":"string"},"logoUrl":{"type":"string","nullable":true},"websiteUrl":{"type":"string","nullable":true},"description":{"type":"string","nullable":true},"tags":{"type":"array","items":{"type":"string"}},"matchedOn":{"type":"string","enum":["name","alias","tag","routing","domain","fts","live"]},"provisional":{"type":"boolean"},"accountTypes":{"type":"array","items":{"type":"string"}},"ways":{"type":"array","items":{"type":"object","properties":{"providerInstanceId":{"type":"string"},"providerInstitutionId":{"type":"string","nullable":true},"targeting":{"type":"string","enum":["portal","picker"]},"consent":{"type":"string","nullable":true,"enum":["cdr","psd2",null]},"recommended":{"type":"boolean"},"health":{"type":"string","enum":["healthy","degraded","unknown"]},"waitlistOnly":{"type":"boolean"},"ineligibleReason":{"type":"string","nullable":true,"enum":["instance_disabled","provider_down","admin_discouraged","portal_hidden","no_portal",null]}},"required":["providerInstanceId","providerInstitutionId","targeting","consent","recommended","health","waitlistOnly","ineligibleReason"]}}},"required":["key","name","slug","market","logoUrl","websiteUrl","description","tags","matchedOn","provisional","ways"]}}},"required":["brands"]}},"required":["success","data"]}}}},"400":{"description":"Invalid request","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"The bank catalog is not enabled in this environment","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/brands/{brandId}":{"get":{"operationId":"getBrand","summary":"Get a bank","description":"One bank and every way to connect it, including which we recommend, how much history stands behind that recommendation, and any way we cannot offer here — kept visible with its reason rather than dropped, because an absence reads as \"this bank is unreachable\".","tags":["Banks"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"institutions","x-flagbase-operation":"institutions.get","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.institutions.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["institutions:read"],"x-flagbase-service-level":"first-class","parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"brandId","in":"path"}],"responses":{"200":{"description":"The bank","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"brand":{"type":"object","properties":{"key":{"type":"string"},"name":{"type":"string"},"slug":{"type":"string"},"market":{"type":"string"},"logoUrl":{"type":"string","nullable":true},"websiteUrl":{"type":"string","nullable":true},"description":{"type":"string","nullable":true},"tags":{"type":"array","items":{"type":"string"}},"institutionType":{"type":"string","nullable":true},"accountTypes":{"type":"array","items":{"type":"string"}},"ways":{"type":"array","items":{"type":"object","properties":{"providerInstanceId":{"type":"string"},"providerInstitutionId":{"type":"string","nullable":true},"targeting":{"type":"string","enum":["portal","picker"]},"consent":{"type":"string","nullable":true,"enum":["cdr","psd2",null]},"recommended":{"type":"boolean"},"health":{"type":"string","enum":["healthy","degraded","unknown"]},"waitlistOnly":{"type":"boolean"},"ineligibleReason":{"type":"string","nullable":true,"enum":["instance_disabled","provider_down","admin_discouraged","portal_hidden","no_portal",null]},"providerLabel":{"type":"string"},"portalCount":{"type":"integer","minimum":0},"oauthSupported":{"type":"boolean"},"products":{"type":"array","items":{"type":"string"}},"attempts":{"type":"number"},"sampleSufficient":{"type":"boolean"},"note":{"type":"object","nullable":true,"properties":{"hint":{"type":"string"},"severity":{"type":"string","enum":["info","degraded","broken"]}},"required":["hint","severity"]}},"required":["providerInstanceId","providerInstitutionId","targeting","consent","recommended","health","waitlistOnly","ineligibleReason","providerLabel","portalCount","oauthSupported","products","attempts","sampleSufficient","note"]}},"explored":{"type":"boolean"}},"required":["key","name","slug","market","logoUrl","websiteUrl","description","tags","institutionType","accountTypes","ways","explored"]}},"required":["brand"]}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Bank not found, or the bank catalog is not enabled in this environment","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/{bid}/accounts":{"get":{"operationId":"listAccounts","summary":"List accounts for a bank","description":"Responses may be served from a cache up to 6 hours old: `X-BankSync-Cache` says `hit`, `miss` or `bypass`, and `Age` is the cached answer's age in seconds.","tags":["Accounts"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"}],"responses":{"200":{"description":"List of accounts","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"bankId":{"type":"string"},"accountNumber":{"type":"string"},"accountName":{"type":"string"},"accountType":{"type":"string"},"balance":{"type":"number","nullable":true},"availableBalance":{"type":"number","nullable":true},"currency":{"type":"string"},"createdAt":{"type":"string"},"updatedAt":{"type":"string"},"links":{"type":"object","additionalProperties":{"type":"string"}}},"required":["id","bankId","accountNumber","accountType","balance","availableBalance","currency","createdAt","updatedAt","links"],"additionalProperties":{"nullable":true}}}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"409":{"description":"The bank needs reconnecting and no accounts are cached (`code` `reauth_required`, `recovery.action` `reconnect`, `reconnectUrl` where to reconnect it) — never an empty list that reads as \"this bank has no accounts\"","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}},"reconnectUrl":{"type":"string"}},"required":["success","error"]}}}}}}},"/v1/banks/{bid}/accounts/{aid}":{"get":{"operationId":"getAccount","summary":"Get an account","description":"Responses may be served from a cache up to 6 hours old: `X-BankSync-Cache` says `hit`, `miss` or `bypass`, and `Age` is the cached answer's age in seconds.","tags":["Accounts"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"},{"schema":{"type":"string","description":"Account ID"},"required":true,"description":"Account ID","name":"aid","in":"path"}],"responses":{"200":{"description":"Account detail","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"id":{"type":"string"},"bankId":{"type":"string"},"accountNumber":{"type":"string"},"accountName":{"type":"string"},"accountType":{"type":"string"},"balance":{"type":"number","nullable":true},"availableBalance":{"type":"number","nullable":true},"currency":{"type":"string"},"createdAt":{"type":"string"},"updatedAt":{"type":"string"},"links":{"type":"object","additionalProperties":{"type":"string"}}},"required":["id","bankId","accountNumber","accountType","balance","availableBalance","currency","createdAt","updatedAt","links"],"additionalProperties":{"nullable":true}}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/{bid}/accounts/{aid}/transactions":{"get":{"operationId":"listTransactions","summary":"List transactions for an account","description":"Date-range reads (`from`/`to`, and every read on providers without incremental sync) page with `cursor`. Incremental-sync reads are always live. Responses may be served from a cache up to 6 hours old: `X-BankSync-Cache` says `hit`, `miss` or `bypass`, and `Age` is the cached answer's age in seconds.","tags":["Transactions"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"banks","x-flagbase-operation":"banks.transactions.list","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.banks.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["banks:read"],"x-flagbase-service-level":"first-class","parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"},{"schema":{"type":"string","description":"Account ID"},"required":true,"description":"Account ID","name":"aid","in":"path"},{"schema":{"type":"string","description":"Continuation cursor from the previous response; retain from/to for date-range pages"},"required":false,"description":"Continuation cursor from the previous response; retain from/to for date-range pages","name":"cursor","in":"query"},{"schema":{"type":"string","pattern":"^\\d{4}-\\d{2}-\\d{2}$","description":"Start date (YYYY-MM-DD), inclusive. Defaults to 30 days before `to`."},"required":false,"description":"Start date (YYYY-MM-DD), inclusive. Defaults to 30 days before `to`.","name":"from","in":"query"},{"schema":{"type":"string","pattern":"^\\d{4}-\\d{2}-\\d{2}$","description":"End date (YYYY-MM-DD), inclusive. Defaults to today (UTC)."},"required":false,"description":"End date (YYYY-MM-DD), inclusive. Defaults to today (UTC).","name":"to","in":"query"}],"responses":{"200":{"description":"List of transactions","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"date":{"type":"string"},"authorizedDate":{"type":"string"},"description":{"type":"string"},"merchantName":{"type":"string"},"originalDescription":{"type":"string"},"cardLast4":{"type":"string"},"cardholder":{"type":"string"},"amount":{"type":"number"},"creditAmount":{"type":"number"},"debitAmount":{"type":"number"},"currency":{"type":"string"},"category":{"type":"string"},"providerCategory":{"type":"string"},"type":{"type":"string"},"reference":{"type":"string"},"pending":{"type":"boolean"},"pendingTransactionId":{"type":"string","nullable":true},"accountId":{"type":"string"},"accountName":{"type":"string"},"accountNumber":{"type":"string"},"accountType":{"type":"string"},"bankId":{"type":"string"},"bank":{"type":"string"}},"required":["id","date","description","amount","creditAmount","debitAmount","currency","category","type","pending","accountId","bankId"],"additionalProperties":{"nullable":true}}},"meta":{"type":"object","properties":{"count":{"type":"number"},"cursor":{"type":"string","nullable":true},"hasMore":{"type":"boolean"},"from":{"type":"string"},"to":{"type":"string"},"partial":{"type":"boolean","enum":[true]}},"required":["count"]},"modified":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"date":{"type":"string"},"authorizedDate":{"type":"string"},"description":{"type":"string"},"merchantName":{"type":"string"},"originalDescription":{"type":"string"},"cardLast4":{"type":"string"},"cardholder":{"type":"string"},"amount":{"type":"number"},"creditAmount":{"type":"number"},"debitAmount":{"type":"number"},"currency":{"type":"string"},"category":{"type":"string"},"providerCategory":{"type":"string"},"type":{"type":"string"},"reference":{"type":"string"},"pending":{"type":"boolean"},"pendingTransactionId":{"type":"string","nullable":true},"accountId":{"type":"string"},"accountName":{"type":"string"},"accountNumber":{"type":"string"},"accountType":{"type":"string"},"bankId":{"type":"string"},"bank":{"type":"string"}},"required":["id","date","description","amount","creditAmount","debitAmount","currency","category","type","pending","accountId","bankId"],"additionalProperties":{"nullable":true}}},"removed":{"type":"array","items":{"type":"string"}},"links":{"type":"object","properties":{"self":{"type":"string"},"account":{"type":"string"},"next":{"type":"string"}},"required":["self","account"]}},"required":["success","data","meta"]}}}},"400":{"description":"Invalid request or continuation cursor","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Account not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"409":{"description":"Reconnect required (`reauth_required`, `reconnectUrl` where to reconnect the bank) or pagination restart required","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}},"reconnectUrl":{"type":"string"}},"required":["success","error"]}}}},"423":{"description":"Provider restricted the connection","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"425":{"description":"Provider data is not ready","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"429":{"description":"Rate limit reached: the workspace plan limit (see Retry-After) or the bank provider limit","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"500":{"description":"Unexpected service failure","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"502":{"description":"Provider configuration failure","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"503":{"description":"Provider temporarily unavailable","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}}}}},"/v1/banks/{bid}/accounts/{aid}/balances":{"get":{"operationId":"getBalance","summary":"Get the latest known balance for an account","description":"Returns the bank aggregator's most recent balance snapshot for the account. This does not force the institution to recompute the balance — aggregators refresh on their own schedule (often daily, and for brokerage accounts only once the institution posts an update). Compare `balanceAsOf` (when the data was refreshed) with `retrievedAt` (when BankSync read it from the aggregator — the cached answer's time on a cache hit) to judge freshness; `balanceAsOf` is null when the provider does not report it, which means UNKNOWN rather than fresh. Responses may be served from a cache up to 6 hours old: `X-BankSync-Cache` says `hit`, `miss` or `bypass`, and `Age` is the cached answer's age in seconds.","tags":["Balances"],"security":[{"apiKey":[]},{"bearerAuth":[]}],"x-flagbase-capability":"banks","x-flagbase-operation":"banks.balance.get","x-flagbase-effects":["read"],"x-flagbase-authorization":"workspace membership, role, and credential scope enforcement","x-flagbase-access-policy":"banksync.automation.banks.read","x-flagbase-trust-domain":"automation","x-flagbase-access-policy-registry-digest":"50b604393609664f3eaba5c77387d96b7c04e7d481e1050215ad8209635f8cd1","x-flagbase-permission-catalog-digest":"2ec5326d465db948f9b12ebb0e3928ea2df3945946338a2e68493cd9928d89d3","x-flagbase-credential-classes":["api-key","oauth-app"],"x-flagbase-tenant-boundary":"workspace","x-flagbase-scopes":["banks:read"],"x-flagbase-service-level":"first-class","parameters":[{"schema":{"type":"string","description":"Bank ID"},"required":true,"description":"Bank ID","name":"bid","in":"path"},{"schema":{"type":"string","description":"Account ID"},"required":true,"description":"Account ID","name":"aid","in":"path"}],"responses":{"200":{"description":"Live balance for the account","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[true]},"data":{"type":"object","properties":{"date":{"type":"string"},"retrievedAt":{"type":"string"},"balanceAsOf":{"type":"string","nullable":true},"bank":{"type":"string"},"account":{"type":"string"},"accountName":{"type":"string"},"accountNumber":{"type":"string"},"accountType":{"type":"string"},"accountId":{"type":"string"},"bankId":{"type":"string"},"amount":{"type":"number"},"availableBalance":{"type":"number","nullable":true},"pendingBalance":{"type":"number"},"creditLimit":{"type":"number"},"currency":{"type":"string"}},"required":["date","account","accountName","accountNumber","accountType","accountId","bankId","amount","availableBalance","currency"]}},"required":["success","data"]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"404":{"description":"Account not found","content":{"application/json":{"schema":{"type":"object","properties":{"success":{"type":"boolean","enum":[false]},"error":{"type":"string"},"code":{"type":"string"},"recovery":{"oneOf":[{"type":"object","properties":{"action":{"type":"string","enum":["retry"]},"afterSeconds":{"type":"integer","minimum":1,"maximum":86400}},"required":["action","afterSeconds"]},{"type":"object","properties":{"action":{"type":"string","enum":["restart_pagination"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["resync"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["reconnect"]}},"required":["action"]},{"type":"object","properties":{"action":{"type":"string","enum":["contact_support"]}},"required":["action"]}]},"referenceId":{"type":"string"},"details":{"type":"array","items":{"type":"object","properties":{"field":{"type":"string"},"message":{"type":"string"}},"required":["message"]}}},"required":["success","error"]}}}},"501":{"des
[...]
